---
type: api
title: Get index segments
description: **All methods and paths for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/operation/operation-indices-segments
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/operation/operation-indices-segments
products:
  - Elasticsearch
---

# Get index segments


Availability:

## Paths

- `GET` `/{index}/_segments`
- `GET` `/_segments`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/authentication#apikeyauth)
- [Basic auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/authentication#basicauth)
- [Bearer auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/authentication#bearerauth)

#### Path Parameters

- `index` (union IndexName | [] IndexName) — optional, leave it out to use `/_segments`
  Comma-separated list of data streams, indices, and aliases used to limit the request.
Supports wildcards (`*`).
To target all data streams and indices, omit this parameter or use `*` or `_all`.

## Description

Get low-level information about the Lucene segments in index shards.
For data streams, the API returns information about the stream's backing indices.

## Required authorization

* Index privileges: `monitor`

## Query String Parameters

- `allow_no_indices` (boolean · default: true)
  If `false`, the request returns an error if any wildcard expression, index alias, or `_all` value targets only missing or closed indices.
This behavior applies even if the request targets other open indices.
- `expand_wildcards` (string ExpandWildcards · default: open)
  Type of index that wildcard patterns can match.
If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams.
Supports comma-separated values, such as `open,hidden`.

Supported values include:
  - `all`: Match any data stream or index, including hidden ones.
  - `open`: Match open, non-hidden indices. Also matches any non-hidden data stream.
  - `closed`: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  - `hidden`: Match hidden data streams and hidden indices. Must be combined with `open`, `closed`, or `both`.
  - `none`: Wildcard expressions are not accepted.
  Values: `all`, `open`, `closed`, `hidden`, `none`
- `ignore_unavailable` (boolean · default: false)
  If `false`, the request returns an error if it targets a missing or closed index.
- `verbose` (boolean · default: false)
  If `true`, the request returns a verbose response.

## Response

`application/json`

- `indices` (map string to IndexSegment)
  Map values ({} IndexSegment)
  - `shards` (map string to oneOf)
- `_shards` ({} ShardStatistics)
  - `failed` (number uint)
    The number of shards the operation or search attempted to run on but failed.
  - `successful` (number uint)
    The number of shards the operation or search succeeded on.
  - `total` (number uint)
    The number of shards the operation or search will run on overall.
  - `failures` ([] ShardFailure)
    - `index` (string IndexName)
    - `node` (string)
    - `reason` ({} ErrorCause)
      - `type` (string)
        The type of error
      - `reason` (union string) — nullable
        A human-readable explanation of the error, in English.
        One of: `string`
      - `stack_trace` (string)
        The server stack trace. Present only if the `error_trace=true` parameter was sent with the request.
      - `caused_by` ({} ErrorCause) — recursive
        Same fields as `reason` in `failures`
      - `root_cause` ([] ErrorCause) — recursive
        Same fields as `reason` in `failures`
      - `suppressed` ([] ErrorCause) — recursive
        Same fields as `reason` in `failures`
    - `shard` (number)
    - `status` (string)
    - `primary` (boolean)
  - `skipped` (number uint)
## Code Examples

#### Console

```console
GET /my-index-000001/_segments
```

#### JavaScript

```javascript
const response = await client.indices.segments({
  index: "my-index-000001",
});
```

#### Python

```python
resp = client.indices.segments(
    index="my-index-000001",
)
```

#### curl

```curl
curl -X GET "$ELASTICSEARCH_URL/my-index-000001/_segments" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY"
```

#### Java

```java
client.indices().segments(s -> s
    .index("my-index-000001")
);
```

#### C#

```c#
var response = await client.Indices
    .SegmentsAsync(d1 => d1
        .Indices(new[] { "my-index-000001" })
    );
```

#### PHP

```php
$resp = $client->indices()->segments([
    "index" => "my-index-000001",
]);
```

#### Ruby

```ruby
response = client.indices.segments(
  index: "my-index-000001"
)
```

## Response Examples

#### Indices segments response example1

A response describing information about index segments.

```json
{
  "_shards": {
    "total": 2,
    "successful": 2,
    "failed": 0
  },
  "indices": {
    "kibana_sample_data_ecommerce": {
      "shards": {
        "0": [
          {
            "routing": {
              "state": "STARTED",
              "primary": false,
              "node": "zZg9NuPhQPKO3LMRkMo2iw"
            },
            "num_committed_segments": 4,
            "num_search_segments": 4,
            "segments": {
              "_0": {
                "generation": 0,
                "num_docs": 500,
                "deleted_docs": 0,
                "size_in_bytes": 524718,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_1": {
                "generation": 1,
                "num_docs": 500,
                "deleted_docs": 0,
                "size_in_bytes": 526100,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_2": {
                "generation": 2,
                "num_docs": 2000,
                "deleted_docs": 0,
                "size_in_bytes": 1846181,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_3": {
                "generation": 3,
                "num_docs": 1675,
                "deleted_docs": 0,
                "size_in_bytes": 1572960,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              }
            }
          },
          {
            "routing": {
              "state": "STARTED",
              "primary": true,
              "node": "sp27SQiNTQWKpBKoRcnfQQ"
            },
            "num_committed_segments": 5,
            "num_search_segments": 5,
            "segments": {
              "_0": {
                "generation": 0,
                "num_docs": 187,
                "deleted_docs": 0,
                "size_in_bytes": 227245,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_1": {
                "generation": 1,
                "num_docs": 253,
                "deleted_docs": 0,
                "size_in_bytes": 297549,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_2": {
                "generation": 2,
                "num_docs": 560,
                "deleted_docs": 0,
                "size_in_bytes": 580918,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_3": {
                "generation": 3,
                "num_docs": 1603,
                "deleted_docs": 0,
                "size_in_bytes": 1506385,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_4": {
                "generation": 4,
                "num_docs": 2072,
                "deleted_docs": 0,
                "size_in_bytes": 1913051,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              }
            }
          }
        ]
      }
    }
  }
}
```

